diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
index 99fb52b9f..e00523025 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockWireRedstone;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
 
@@ -20,7 +21,6 @@ public class BlockModelWireRedstone<T extends Block> extends BlockModelStandard<
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         IconCoordinate straight = wireStraight;
         IconCoordinate cross = wireCross;
@@ -31,14 +31,14 @@ public class BlockModelWireRedstone<T extends Block> extends BlockModelStandard<
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
 //            int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
-//            if(Block.lightEmission[block.id] > 0) {
+//            if(Blocks.lightEmission[block.id] > 0) {
 //                lmc = LightmapHelper.setBlocklightValue(lmc, 15);
 //            }
             int lmc = LightmapHelper.getLightmapCoord(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Sky, x, y, z), Math.max(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Block, x, y, z), meta & 0xF));
             tessellator.setLightmapCoord(lmc);
         }else {
             brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-            if(Block.lightEmission[block.id] > 0) {
+            if(Blocks.lightEmission[block.id] > 0) {
                 brightness = 1.0f;
             }
             brightness = Math.max(brightness, (meta & 0xF)/16f);
diff --git a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
similarity index 96%
rename from src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
rename to game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
index b38cf42e6..08127f80e 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
@@ -9,6 +9,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlowerJar;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
@@ -28,7 +29,7 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
     @Override
     public void doRender(Tessellator tessellator, TileEntityFlowerJar tileEntity, double x, double y, double z, float renderPartialTicks) {
         GL11.glPushMatrix();
-        Block block = Block.getBlock(tileEntity.flowerInPot);
+        Block block = Blocks.getBlock(tileEntity.flowerInPot);
         if(block != null){
             GL11.glTranslatef((float)x, (float)y, (float)z);
             TextureRegistry.blockAtlas.bind();
diff --git a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
rename to game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
index 95028fa1b..9a3d63afd 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
@@ -44,7 +44,7 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
 	public void doRender(Tessellator tessellator, TileEntityMovingPistonBlock blockEntity, double x, double y, double z,
                          float partialTick)
     {
-        Block block = Block.blocksList[blockEntity.getMovedId()];
+        Block block = Blocks.blocksList[blockEntity.getMovedId()];
         if(block != null && blockEntity.getProgress(partialTick) < 1.0F)
         {
             if (container == null || container.world != blockEntity.worldObj) {
diff --git a/src/main/java/net/minecraft/client/render/camera/CameraUtil.java b/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
similarity index 92%
rename from src/main/java/net/minecraft/client/render/camera/CameraUtil.java
rename to game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
index 63f9ae7fc..276710b8c 100644
--- a/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
@@ -1,40 +1,41 @@
-package net.minecraft.client.render.camera;
-
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
-import net.minecraft.core.world.World;
-
-public abstract class CameraUtil
-{
-    public static HitResult traceRay(ICamera camera, World world, double distance, float partialTick)
-    {
-        Vec3 pos = camera.getPosition(partialTick);
-        Vec3 rot = camera.getRotationVector(partialTick);
-        Vec3 endPos = pos.add(rot.x * distance, rot.y * distance, rot.z * distance);
-        return world.checkBlockCollisionBetweenPoints(pos, endPos);
-    }
-
-    public static boolean isUnderLiquid(ICamera camera, World world, Material material, float partialTick)
-    {
-        double cameraY = camera.getY(partialTick);
-        int x = MathHelper.floor(camera.getX(partialTick));
-        int y = MathHelper.floor_float(MathHelper.floor(cameraY));
-        int z = MathHelper.floor(camera.getZ(partialTick));
-        int id = world.getBlockId(x, y, z);
-        if(id != 0 && Block.blocksList[id].blockMaterial == material)
-        {
-            float f = BlockFluid.getWaterVolume(world.getBlockMetadata(x, y, z)) - 0.2F;
-            float f1 = (float)(y + 1) - f;
-            return cameraY < (double)f1;
-        }
-        else
-        {
-            return false;
-        }
-
-    }
-}
+package net.minecraft.client.render.camera;
+
+import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+
+public abstract class CameraUtil
+{
+    public static HitResult traceRay(ICamera camera, World world, double distance, float partialTick)
+    {
+        Vec3 pos = camera.getPosition(partialTick);
+        Vec3 rot = camera.getRotationVector(partialTick);
+        Vec3 endPos = pos.add(rot.x * distance, rot.y * distance, rot.z * distance);
+        return world.checkBlockCollisionBetweenPoints(pos, endPos);
+    }
+
+    public static boolean isUnderLiquid(ICamera camera, World world, Material material, float partialTick)
+    {
+        double cameraY = camera.getY(partialTick);
+        int x = MathHelper.floor(camera.getX(partialTick));
+        int y = MathHelper.floor_float(MathHelper.floor(cameraY));
+        int z = MathHelper.floor(camera.getZ(partialTick));
+        int id = world.getBlockId(x, y, z);
+        if(id != 0 && Blocks.blocksList[id].blockMaterial == material)
+        {
+            float f = BlockFluid.getWaterVolume(world.getBlockMetadata(x, y, z)) - 0.2F;
+            float f1 = (float)(y + 1) - f;
+            return cameraY < (double)f1;
+        }
+        else
+        {
+            return false;
+        }
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
rename to game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
index 43e2cbf51..09da687bc 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
@@ -52,8 +52,8 @@ public class EntityCameraThirdPersonRear
                     Vec3.getTempVec3(x, y, z),
                     Vec3.getTempVec3(x - i * dx, y - i * dy, z - i * dz),
                     false,
-                    true
-            );
+                    true,
+                false);
             if(hitResult != null)
             {
                 double distance = hitResult.location.distanceTo(Vec3.getTempVec3(x, y, z)) - offset;
diff --git a/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
rename to game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index fb7eccdde..64d21cf63 100644
--- a/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.core.block.Blocks;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
@@ -128,7 +129,7 @@ public abstract class EntityRenderer<T extends Entity>
                     int blockId = world.getBlockId(blockX, blockY - 1, blockZ);
                     if(blockId > 0 && world.getBlockLightValue(blockX, blockY, blockZ) > 3)
                     {
-                        renderShadowOnBlock(tessellator, entity, Block.blocksList[blockId], posX, posY + (double)entity.getShadowHeightOffs(), posZ, blockX, blockY, blockZ, opacity, shadowSize, dxLerp, dyLerp + (double)entity.getShadowHeightOffs(), dzLerp);
+                        renderShadowOnBlock(tessellator, entity, Blocks.blocksList[blockId], posX, posY + (double)entity.getShadowHeightOffs(), posZ, blockX, blockY, blockZ, opacity, shadowSize, dxLerp, dyLerp + (double)entity.getShadowHeightOffs(), dzLerp);
                     }
                 }
 
diff --git a/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
similarity index 93%
rename from src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
rename to game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
index b798a9b5b..7722ad905 100644
--- a/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
@@ -9,6 +9,7 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.blockentity.TileEntityRenderer;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.world.BlocksContainer;
@@ -60,7 +61,7 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
 
         container.setLightReferenceEntity(fallingBlock);
         container.setBlock(blockX, blockY, blockZ, fallingBlock.carriedBlock.blockId, fallingBlock.carriedBlock.metadata, fallingBlock.carriedBlock.entity);
-        BlockModelDispatcher.getInstance().getDispatch(Block.getBlock(fallingBlock.carriedBlock.blockId)).renderNoCulling(Tessellator.instance, blockX, blockY, blockZ);
+        BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(fallingBlock.carriedBlock.blockId)).renderNoCulling(Tessellator.instance, blockX, blockY, blockZ);
         container.setLightReferenceEntity(null);
         container.clear();
 
diff --git a/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
similarity index 95%
rename from src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
rename to game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
index 5b07ba9fd..c0b28b691 100644
--- a/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
@@ -43,16 +43,15 @@ public class MobRendererFireflyCluster extends EntityRenderer<MobFireflyCluster>
 
 		GL11.glPushMatrix();
 		GL11.glTranslatef(0, 0.75f, 0);
-		GL11.glDisable(GL11.GL_CULL_FACE);
 		GL11.glEnable(GL11.GL_TEXTURE_2D);
+		GL11.glEnable(GL11.GL_BLEND);
 		Lighting.disable();
 		TextureRegistry.particleAtlas.bind();
+		Tessellator t = Tessellator.instance;
+		t.startDrawingQuads();
 		for (int i = 0; i < fireflies.size(); i++) {
 			ParticleFirefly firefly = fireflies.get(i);
-			Tessellator t = Tessellator.instance;
-			t.startDrawingQuads();
 			firefly.renderParticleInGui(t, partialTick);
-			t.draw();
 			for (int j = 0; j < storedTicks; j++) {
 				firefly.tickGui();
 				lastTick = currentTick;
@@ -62,6 +61,7 @@ public class MobRendererFireflyCluster extends EntityRenderer<MobFireflyCluster>
 				i--;
 			}
 		}
+		t.draw();
 		GL11.glEnable(GL11.GL_CULL_FACE);
 		GL11.glPopMatrix();
 
diff --git a/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
rename to game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 7ceb16e4e..19ec797d4 100644
--- a/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -18,6 +18,7 @@ import net.minecraft.client.render.model.ModelPlayer;
 import net.minecraft.client.render.model.ModelPlayerSlim;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.player.Player;
@@ -60,7 +61,7 @@ public class MobRendererPlayer extends MobRenderer<Player>
         {
             GL11.glPushMatrix();
             modelBipedMain.head.translateTo(0.0625F);
-            if(itemstack.itemID < Block.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Block.getBlock(itemstack.itemID)).shouldItemRender3d())
+            if(itemstack.itemID < Blocks.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(itemstack.itemID)).shouldItemRender3d())
             {
                 float scale = 0.625F;
                 GL11.glTranslatef(0.0F, -0.25F, 0.0F);
diff --git a/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
similarity index 94%
rename from src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
rename to game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index 8f61b37e7..676d11172 100644
--- a/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.ModelWolf;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.animal.MobWolf;
 
 import net.minecraft.core.item.ItemStack;
@@ -60,7 +61,7 @@ public class MobRendererWolf extends MobRenderer<MobWolf>
             modelWolfMain.wolfHeadMain.translateTo(0.0625F);
             GL11.glTranslatef(-0.0625F, 0.4375F, 0.0625F);
             float scale;
-            if (itemstack.itemID > 0 && itemstack.itemID < Block.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).shouldItemRender3d()) {
+            if (itemstack.itemID > 0 && itemstack.itemID < Blocks.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemstack.itemID]).shouldItemRender3d()) {
                 scale = 0.35F;
                 GL11.glTranslatef(0.075F, -0.3F, -0.35F);
                 scale *= 0.75F;
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
similarity index 91%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
rename to game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index dec48e322..ce6ff451d 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -13,6 +13,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
@@ -85,12 +86,12 @@ public class ItemModelBlock extends ItemModelStandard {
     }
     @Override
     public void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, @Nullable Entity entity, float brightness, boolean handheldTransform) {
-        if(BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).shouldItemRender3d())
+        if(BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemstack.itemID]).shouldItemRender3d())
         {
             GL11.glEnable(GL_BLEND);
             GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
             TextureRegistry.blockAtlas.bind();
-            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness, null);
+            BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemstack.itemID]).renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness, null);
             GL11.glDisable(GL_BLEND);
         } else {
             super.renderItem(tessellator, renderer, itemstack, entity, brightness, handheldTransform);
@@ -98,7 +99,7 @@ public class ItemModelBlock extends ItemModelStandard {
     }
     @Override
     public void heldTransformThirdPerson(ItemRenderer renderer, Entity entity, ItemStack itemStack) {
-        if(itemStack.itemID < Block.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).shouldItemRender3d()) {
+        if(itemStack.itemID < Blocks.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).shouldItemRender3d()) {
             final float scale = 0.5F * 0.75F;
             GL11.glTranslatef(0.0F, 0.1875F, -0.3125F);
             GL11.glRotatef(20F, 1.0F, 0.0F, 0.0F);
@@ -114,7 +115,7 @@ public class ItemModelBlock extends ItemModelStandard {
         GL11.glEnable(GL_BLEND);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         GL11.glEnable(GL_CULL_FACE);
-        if (BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).shouldItemRender3d()) {
+        if (BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).shouldItemRender3d()) {
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
             TextureRegistry.blockAtlas.bind();
             GL11.glPushMatrix();
@@ -135,7 +136,7 @@ public class ItemModelBlock extends ItemModelStandard {
             }
             GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
             BlockModel.renderBlocks.useInventoryTint = useColor;
-            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha, null);
+            BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha, null);
             BlockModel.renderBlocks.useInventoryTint = true;
             GL11.glPopMatrix();
         } else {
@@ -147,7 +148,7 @@ public class ItemModelBlock extends ItemModelStandard {
     
     @Override
     public void renderAsItemEntity(Tessellator tessellator, Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick) {
-        if (Block.blocksList[itemstack.itemID] != null && BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).shouldItemRender3d()) {
+        if (Blocks.blocksList[itemstack.itemID] != null && BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemstack.itemID]).shouldItemRender3d()) {
             GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
             TextureRegistry.blockAtlas.bind();
             final float itemSize = blockModel.getItemRenderScale();
@@ -178,10 +179,10 @@ public class ItemModelBlock extends ItemModelStandard {
     @Override
     public void renderItemInWorld(Tessellator tessellator, Entity entity, ItemStack itemStack, float brightness, float alpha, boolean worldTransform) {
         if (itemStack == null) return;
-        GL11.glEnable(GL_BLEND);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         GL11.glEnable(GL_CULL_FACE);
-        if (BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).shouldItemRender3d()) {
+        GL11.glEnable(GL_BLEND);
+        if (BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).shouldItemRender3d()) {
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
             TextureRegistry.blockAtlas.bind();
             if (useColor) {
@@ -195,12 +196,12 @@ public class ItemModelBlock extends ItemModelStandard {
             }
             GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
             BlockModel.renderBlocks.useInventoryTint = useColor;
-            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha, null);
+            BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha, null);
             BlockModel.renderBlocks.useInventoryTint = true;
         } else {
             super.renderItemInWorld(tessellator, entity, itemStack, brightness, alpha, worldTransform);
         }
-        GL11.glEnable(GL_CULL_FACE);
+        GL11.glDisable(GL_CULL_FACE);
         GL11.glDisable(GL_BLEND);
     }
     @Override
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
rename to game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 854d40132..815954ff4 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -230,9 +230,9 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelBlock((ItemBlock) Blocks.PORTAL_PARADISE.asItem()).setFullBright());
         addDispatch(new ItemModelBlock((ItemBlock) Blocks.PORTAL_NETHER.asItem()).setFullBright());
 
-        for (int i = 0; i < Block.blocksList.length; i++) {
-            if (Block.blocksList[i] == null) continue;
-            Item item = Block.blocksList[i].asItem();
+        for (int i = 0; i < Blocks.blocksList.length; i++) {
+            if (Blocks.blocksList[i] == null) continue;
+            Item item = Blocks.blocksList[i].asItem();
             if (dispatches.containsKey(item)) continue;
             if (!(item instanceof ItemBlock)) continue;
             addDispatch(new ItemModelBlock((ItemBlock) item));
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
rename to game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 2493fe0d4..acda003b9 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -136,11 +136,11 @@ public class ItemModelStandard extends ItemModel{
     public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha) {
         if (itemStack == null) return;
         Minecraft mc = Minecraft.getMinecraft(this);
-        glEnable(GL_BLEND);
-        glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        glEnable(GL_CULL_FACE);
-        IconCoordinate textureIndex = getIcon(mc.thePlayer, itemStack);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         GL11.glDisable(GL_LIGHTING);
+        GL11.glEnable(GL_BLEND);
+        GL11.glEnable(GL_CULL_FACE);
+        IconCoordinate textureIndex = getIcon(mc.thePlayer, itemStack);
         textureIndex.parentAtlas.bind();
         if (useColor) {
             final int color = getColor(itemStack);
@@ -152,9 +152,9 @@ public class ItemModelStandard extends ItemModel{
             GL11.glColor4f(brightness, brightness, brightness, alpha);
         }
         renderTexturedQuad(tessellator, x, y, textureIndex);
-        glEnable(GL_LIGHTING);
-        glEnable(GL_CULL_FACE);
-        glDisable(GL11.GL_BLEND);
+        GL11.glEnable(GL_LIGHTING);
+        GL11.glDisable(GL_CULL_FACE);
+        GL11.glDisable(GL11.GL_BLEND);
     }
 
     @Override
@@ -179,7 +179,7 @@ public class ItemModelStandard extends ItemModel{
             GL11.glDisable(GL_LIGHTING);
             GL11.glDisable(GL_DEPTH_TEST);
             GL11.glDisable(GL_TEXTURE_2D);
-            final int colorFG = Color.HSBtoRGB(progress/255F/3F, 1f, 1f);
+            final int colorFG = Color.HSBtoRGB(progress / 255F / 3F, 1f, 1f);
             final int colorBG = (0xFF - progress) / 4 << 16 | 0x3f00;
             renderColoredQuad(tessellator, x + 2, y + 13, 13, 2, 0, a);
             renderColoredQuad(tessellator, x + 2, y + 13, 12, 1, colorBG, a);
diff --git a/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
similarity index 97%
rename from src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
rename to game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index a964f5ffb..ef4d0cb97 100644
--- a/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -100,9 +100,8 @@ public abstract class ChunkRenderer
     
     public abstract void rebuild();
     
-    public boolean renderBlock(Tessellator tessellator, RenderBlocks renderBlocks, Block block, int x, int y, int z) {
+    public boolean renderBlock(Tessellator tessellator, RenderBlocks renderBlocks, BlockModel<?> model, int x, int y, int z) {
     	boolean rendered = false;
-		final BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(block);
 		rendered |= model.render(tessellator, x, y, z);
 		if(model.hasOverbright()) {
 			renderBlocks.overbright = true;
